Bug 443626 - Pluto segfault with host-to-host config and other host down
Pluto segfault with host-to-host config and other host down
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: openswan (Show other bugs)
5.2
All Linux
low Severity low
: rc
: ---
Assigned To: Avesh Agarwal
http://bugs.xelerance.com/view.php?id...
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-04-22 11:58 EDT by Jakub Hrozek
Modified: 2009-09-02 07:19 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 07:19:37 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
ipsec.conf (1.34 KB, text/plain)
2008-04-22 11:58 EDT, Jakub Hrozek
no flags Details
pluto core file (41.19 KB, application/octet-stream)
2008-04-24 12:44 EDT, Jakub Hrozek
no flags Details
Rewrite ikev2->ikev1 fallback code (1.81 KB, patch)
2008-05-12 04:43 EDT, Miloslav Trmač
no flags Details | Diff

  None (edit)
Description Jakub Hrozek 2008-04-22 11:58:59 EDT
Description of problem:
If I configure simple host-to-host connection while the other host is down, 
pluto segfaults within few minutes.


Version-Release number of selected component (if applicable):
openswan-2.6.11-1.el5

How reproducible:
100%

Steps to Reproduce:
1. configure host-to-host IPsec connection (my ipsec.conf attached)
2. turn off one host
3. service ipsec restart 
4. pluto will segfault within few minutes  

Actual results:
Apr 22 17:45:22 xen15 ipsec__plutorun: /usr/libexec/ipsec/_plutorun: line 250:  
4806 Segmentation 
fault      /usr/libexec/ipsec/pluto --nofork --secretsfile /etc/ipsec.secrets --use-netkey --nat_traversal


Expected results:
no segfault

Additional info:
I haven't been able to grab a core file - is there anything I might be missing 
apart from having ulimit -c unlimited?
Comment 1 Jakub Hrozek 2008-04-22 11:58:59 EDT
Created attachment 303332 [details]
ipsec.conf
Comment 3 Steve Grubb 2008-04-22 14:26:54 EDT
A new openswan package 2.6.12-1 was built recently. Not sure if this was fixed
already in the new package.
Comment 4 Jakub Hrozek 2008-04-23 08:35:14 EDT
(In reply to comment #3)
> A new openswan package 2.6.12-1 was built recently. Not sure if this was 
fixed
> already in the new package.

Nope, still there with 2.6.12
Comment 5 Miloslav Trmač 2008-04-23 15:31:23 EDT
Adding "ikev2=always" to the tunnel configuration avoids the crash - but
disables automatic downgrade to IKEv1.  There might be other side effects as well.

To grab a core file, add e.g. "dumpdir=/tmp" to the "config setup" section.
Comment 6 Jakub Hrozek 2008-04-24 12:44:49 EDT
Created attachment 303661 [details]
pluto core file

Thanks for the pointer, Mirek. Here goes the core file..
Comment 7 Miloslav Trmač 2008-05-12 04:43:55 EDT
Created attachment 305104 [details]
Rewrite ikev2->ikev1 fallback code

The attached patch fixes the crash, but I have only tested it in the provided
configuration, not with any peer.

See http://bugs.xelerance.com/view.php?id=922 for the upstream bug report and
possible discussion.
Comment 8 RHEL Product and Program Management 2008-06-02 16:04:58 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 9 Steve Grubb 2008-09-19 09:57:44 EDT
This patch appears to be included in 2.6.14.
Comment 15 errata-xmlrpc 2009-09-02 07:19:37 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHEA-2009-1350.html

Note You need to log in before you can comment on or make changes to this bug.